qlserver 4.0 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151
  1. #!/bin/bash
  2. # Quake Live
  3. # Server Management Script
  4. # Author: Daniel Gibbs
  5. # Website: http://gameservermanagers.com
  6. if [ -f ".dev-debug" ]; then
  7. exec 5>dev-debug.log
  8. BASH_XTRACEFD="5"
  9. set -x
  10. fi
  11. version="150316"
  12. #### Variables ####
  13. arch="x64"
  14. # Notification Email
  15. # (on|off)
  16. emailnotification="off"
  17. email="email@example.com"
  18. # Steam login
  19. steamuser="anonymous"
  20. steampass=""
  21. # Start Variables
  22. gameport="27960"
  23. rconport="28960"
  24. rconpassword="CHANGE_ME"
  25. statsport="${gameport}"
  26. statspassword="CHANGE_ME"
  27. mappool='mappool.txt'
  28. ip="0.0.0.0"
  29. updateonstart="off"
  30. # Install/Config Guide : https://steamcommunity.com/sharedfiles/filedetails/?id=542966946
  31. # Console Commands : http://www.regurge.at/ql/
  32. fn_parms(){
  33. parms="+set net_strict 1 +set net_ip ${ip} +set net_port ${gameport} +set fs_homepath ${filesdir}/${gameport} +set zmq_rcon_enable 1 +set zmq_rcon_port ${rconport} +set zmq_rcon_password ${rconpassword} +set zmq_stats_enable 1 +set zmq_stats_password ${statspassword} +set zmq_stats_port ${statsport} +set sv_mapPoolFile ${mappool} +exec ${servercfg} "
  34. }
  35. #### Advanced Variables ####
  36. # Github Branch Select
  37. # Allows for the use of different function files
  38. # from a different repo and/or branch.
  39. githubuser="dgibbs64"
  40. githubrepo="linuxgsm"
  41. githubbranch="master"
  42. # Steam
  43. appid="349090"
  44. # Server Details
  45. servicename="ql-server"
  46. gamename="Quake Live"
  47. engine="idtech3"
  48. # Directories
  49. rootdir="$(dirname $(readlink -f "${BASH_SOURCE[0]}"))"
  50. selfname="$(basename $(readlink -f "${BASH_SOURCE[0]}"))"
  51. lockselfname=".${servicename}.lock"
  52. lgsmdir="${rootdir}/lgsm"
  53. functionsdir="${lgsmdir}/functions"
  54. filesdir="${rootdir}/serverfiles"
  55. systemdir="${filesdir}"
  56. executabledir="${filesdir}"
  57. executable=$([ "$arch" == 'x64' ] && echo "./run_server_x64.sh" || echo "./run_server_x86.sh")
  58. servercfg="${servicename}.cfg"
  59. servercfgdir="${filesdir}/baseq3"
  60. servercfgfullpath="${servercfgdir}/${servercfg}"
  61. servercfgdefault="${servercfgdir}/lgsm-default.cfg"
  62. backupdir="${rootdir}/backups"
  63. # Logging
  64. logdays="7"
  65. gamelogdir="${rootdir}/log/server"
  66. scriptlogdir="${rootdir}/log/script"
  67. consolelogdir="${rootdir}/log/console"
  68. gamelog="${gamelogdir}/${servicename}-game.log"
  69. scriptlog="${scriptlogdir}/${servicename}-script.log"
  70. consolelog="${consolelogdir}/${servicename}-console.log"
  71. emaillog="${scriptlogdir}/${servicename}-email.log"
  72. scriptlogdate="${scriptlogdir}/${servicename}-script-$(date '+%d-%m-%Y-%H-%M-%S').log"
  73. consolelogdate="${consolelogdir}/${servicename}-console-$(date '+%d-%m-%Y-%H-%M-%S').log"
  74. ##### Script #####
  75. # Do not edit
  76. # Fetches core_dl for file downloads
  77. fn_fetch_core_dl(){
  78. github_file_url_dir="lgsm/functions"
  79. github_file_url_name="${functionfile}"
  80. filedir="${functionsdir}"
  81. filename="${github_file_url_name}"
  82. githuburl="https://raw.githubusercontent.com/${githubuser}/${githubrepo}/${githubbranch}/${github_file_url_dir}/${github_file_url_name}"
  83. # If the file is missing, then download
  84. if [ ! -f "${filedir}/${filename}" ]; then
  85. if [ ! -d "${filedir}" ]; then
  86. mkdir -p "${filedir}"
  87. fi
  88. echo -e " fetching ${filename}...\c"
  89. # Check curl exists and use available path
  90. curlpaths="$(command -v curl 2>/dev/null) $(which curl >/dev/null 2>&1) /usr/bin/curl /bin/curl /usr/sbin/curl /sbin/curl)"
  91. for curlcmd in ${curlpaths}
  92. do
  93. if [ -x "${curlcmd}" ]; then
  94. break
  95. fi
  96. done
  97. # If curl exists download file
  98. if [ "$(basename ${curlcmd})" == "curl" ]; then
  99. curlfetch=$(${curlcmd} -s --fail -o "${filedir}/${filename}" "${githuburl}" 2>&1)
  100. if [ $? -ne 0 ]; then
  101. echo -e "\e[0;31mFAIL\e[0m\n"
  102. echo "${curlfetch}"
  103. echo -e "${githuburl}\n"
  104. exit 1
  105. else
  106. echo -e "\e[0;32mOK\e[0m"
  107. fi
  108. else
  109. echo -e "\e[0;31mFAIL\e[0m\n"
  110. echo "Curl is not installed!"
  111. echo -e ""
  112. exit 1
  113. fi
  114. chmod +x "${filedir}/${filename}"
  115. fi
  116. source "${filedir}/${filename}"
  117. }
  118. core_dl.sh(){
  119. # Functions are defined in core_functions.sh.
  120. functionfile="${FUNCNAME}"
  121. fn_fetch_core_dl
  122. }
  123. core_functions.sh(){
  124. # Functions are defined in core_functions.sh.
  125. functionfile="${FUNCNAME}"
  126. fn_fetch_core_dl
  127. }
  128. core_dl.sh
  129. core_functions.sh
  130. getopt=$1
  131. core_getopt.sh